Show / Hide Table of Contents

# Struct Quaternion

##### Implements

IEquatable<Quaternion>

##### Inherited Members

System.Object.Equals(System.Object, System.Object)
System.Object.GetType()
System.Object.ReferenceEquals(System.Object, System.Object)

###### Namespace: FFXIVClientStructs.FFXIV.Common.Math

###### Assembly: FFXIVClientStructs.dll

##### Syntax

    public struct Quaternion

### Constructors

| Improve this Doc View Source

#### Quaternion(Vector3, Single)

##### Declaration

    public Quaternion(Vector3 value, float w)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector3 | value |
System.Single | w |

| Improve this Doc View Source

#### Quaternion(Single)

##### Declaration

    public Quaternion(float value)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | value |

| Improve this Doc View Source

#### Quaternion(Single, Single, Single, Single)

##### Declaration

    public Quaternion(float x, float y, float z, float w)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | x |
System.Single | y |
System.Single | z |
System.Single | w |

### Fields

| Improve this Doc View Source

#### Deg2Rad

##### Declaration

    public const float Deg2Rad = default(float)

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Identity

##### Declaration

    public static readonly Quaternion Identity

##### Field Value

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Rad2Deg

##### Declaration

    public const float Rad2Deg = default(float)

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### W

##### Declaration

    public float W

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### X

##### Declaration

    public float X

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Y

##### Declaration

    public float Y

##### Field Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Z

##### Declaration

    public float Z

##### Field Value

Type | Description
--- | ---
System.Single |

### Properties

| Improve this Doc View Source

#### EulerAngles

##### Declaration

    public Vector3 EulerAngles { get; set; }

##### Property Value

Type | Description
--- | ---
Vector3 |

| Improve this Doc View Source

#### IsIdentity

##### Declaration

    public readonly bool IsIdentity { get; }

##### Property Value

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Magnitude

##### Declaration

    public readonly float Magnitude { get; }

##### Property Value

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Normalized

##### Declaration

    public readonly Quaternion Normalized { get; }

##### Property Value

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### SqrMagnitude

##### Declaration

    public readonly float SqrMagnitude { get; }

##### Property Value

Type | Description
--- | ---
System.Single |

### Methods

| Improve this Doc View Source

#### Angle(Quaternion, Quaternion)

##### Declaration

    public static float Angle(Quaternion from, Quaternion to)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | from |
Quaternion | to |

##### Returns

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Conjugate(Quaternion)

##### Declaration

    public static Quaternion Conjugate(Quaternion value)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | value |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### CreateFromAxisAngle(Vector3, Single)

##### Declaration

    public static Quaternion CreateFromAxisAngle(Vector3 axis, float angle)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector3 | axis |
System.Single | angle |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### CreateFromEuler(Vector3)

##### Declaration

    public static Quaternion CreateFromEuler(Vector3 euler)

##### Parameters

Type | Name | Description
--- | --- | ---
Vector3 | euler |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### CreateFromRotationMatrix(Matrix4x4)

##### Declaration

    public static Quaternion CreateFromRotationMatrix(Matrix4x4 matrix)

##### Parameters

Type | Name | Description
--- | --- | ---
Matrix4x4 | matrix |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### CreateFromYawPitchRoll(Single, Single, Single)

##### Declaration

    public static Quaternion CreateFromYawPitchRoll(float yaw, float pitch, float roll)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Single | yaw |
System.Single | pitch |
System.Single | roll |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Dot(Quaternion, Quaternion)

##### Declaration

    public static float Dot(Quaternion a, Quaternion b)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | a |
Quaternion | b |

##### Returns

Type | Description
--- | ---
System.Single |

| Improve this Doc View Source

#### Equals(Quaternion)

##### Declaration

    public bool Equals(Quaternion other)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | other |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Equals(Object)

##### Declaration

    public override bool Equals(object obj)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Object | obj |

##### Returns

Type | Description
--- | ---
System.Boolean |

##### Overrides

System.ValueType.Equals(System.Object)
| Improve this Doc View Source

#### GetHashCode()

##### Declaration

    public override int GetHashCode()

##### Returns

Type | Description
--- | ---
System.Int32 |

##### Overrides

System.ValueType.GetHashCode()
| Improve this Doc View Source

#### Invert(Quaternion)

##### Declaration

    public static Quaternion Invert(Quaternion value)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | value |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Lerp(Quaternion, Quaternion, Single)

##### Declaration

    public static Quaternion Lerp(Quaternion start, Quaternion end, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | start |
Quaternion | end |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### LerpUnclamped(Quaternion, Quaternion, Single)

##### Declaration

    public static Quaternion LerpUnclamped(Quaternion start, Quaternion end, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | start |
Quaternion | end |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Normalize(Quaternion)

##### Declaration

    public static Quaternion Normalize(Quaternion value)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | value |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Slerp(Quaternion, Quaternion, Single)

##### Declaration

    public static Quaternion Slerp(Quaternion start, Quaternion end, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | start |
Quaternion | end |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### SlerpUnclamped(Quaternion, Quaternion, Single)

##### Declaration

    public static Quaternion SlerpUnclamped(Quaternion start, Quaternion end, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | start |
Quaternion | end |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Squad(Quaternion, Quaternion, Quaternion, Quaternion, Single)

##### Declaration

    public static Quaternion Squad(Quaternion value1, Quaternion value2, Quaternion value3, Quaternion value4, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | value1 |
Quaternion | value2 |
Quaternion | value3 |
Quaternion | value4 |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### SquadUnclamped(Quaternion, Quaternion, Quaternion, Quaternion, Single)

##### Declaration

    public static Quaternion SquadUnclamped(Quaternion value1, Quaternion value2, Quaternion value3, Quaternion value4, float amount)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | value1 |
Quaternion | value2 |
Quaternion | value3 |
Quaternion | value4 |
System.Single | amount |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### ToString()

##### Declaration

    public override string ToString()

##### Returns

Type | Description
--- | ---
System.String |

##### Overrides

System.ValueType.ToString()

### Operators

| Improve this Doc View Source

#### Addition(Quaternion, Quaternion)

##### Declaration

    public static Quaternion operator +(Quaternion a, Quaternion b)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | a |
Quaternion | b |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Equality(Quaternion, Quaternion)

##### Declaration

    public static bool operator ==(Quaternion left, Quaternion right)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | left |
Quaternion | right |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Implicit(Quaternion to Quaternion)

##### Declaration

    public static implicit operator Quaternion(Quaternion q)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | q |

##### Returns

Type | Description
--- | ---
System.Numerics.Quaternion |

| Improve this Doc View Source

#### Implicit(Quaternion to Quaternion)

##### Declaration

    public static implicit operator Quaternion(Quaternion q)

##### Parameters

Type | Name | Description
--- | --- | ---
System.Numerics.Quaternion | q |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Inequality(Quaternion, Quaternion)

##### Declaration

    public static bool operator !=(Quaternion left, Quaternion right)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | left |
Quaternion | right |

##### Returns

Type | Description
--- | ---
System.Boolean |

| Improve this Doc View Source

#### Multiply(Quaternion, Quaternion)

##### Declaration

    public static Quaternion operator *(Quaternion a, Quaternion b)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | a |
Quaternion | b |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Multiply(Quaternion, Vector3)

##### Declaration

    public static Vector3 operator *(Quaternion rotation, Vector3 point)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | rotation |
Vector3 | point |

##### Returns

Type | Description
--- | ---
Vector3 |

| Improve this Doc View Source

#### Multiply(Quaternion, Single)

##### Declaration

    public static Quaternion operator *(Quaternion a, float d)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | a |
System.Single | d |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### Subtraction(Quaternion, Quaternion)

##### Declaration

    public static Quaternion operator -(Quaternion a, Quaternion b)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | a |
Quaternion | b |

##### Returns

Type | Description
--- | ---
Quaternion |

| Improve this Doc View Source

#### UnaryNegation(Quaternion)

##### Declaration

    public static Quaternion operator -(Quaternion a)

##### Parameters

Type | Name | Description
--- | --- | ---
Quaternion | a |

##### Returns

Type | Description
--- | ---
Quaternion |

### Implements

IEquatable<>